diff --git a/drivers/regulator/mt6323-regulator.c b/drivers/regulator/mt6323-regulator.c
index ff9016170db37..8b22ded43ab8a 100644
--- a/drivers/regulator/mt6323-regulator.c
+++ b/drivers/regulator/mt6323-regulator.c
@@ -42,6 +42,7 @@ struct mt6323_regulator_info {
 	.desc = {							\
 		.name = #vreg,						\
 		.of_match = of_match_ptr(match),			\
+		.regulators_node = of_match_ptr("mt6323regulator"),	\
 		.ops = &mt6323_volt_range_ops,				\
 		.type = REGULATOR_VOLTAGE,				\
 		.id = MT6323_ID_##vreg,					\
@@ -66,6 +67,7 @@ struct mt6323_regulator_info {
 	.desc = {							\
 		.name = #vreg,						\
 		.of_match = of_match_ptr(match),			\
+		.regulators_node = of_match_ptr("mt6323regulator"),	\
 		.ops = &mt6323_volt_table_ops,				\
 		.type = REGULATOR_VOLTAGE,				\
 		.id = MT6323_ID_##vreg,					\
@@ -88,6 +90,7 @@ struct mt6323_regulator_info {
 	.desc = {							\
 		.name = #vreg,						\
 		.of_match = of_match_ptr(match),			\
+		.regulators_node = of_match_ptr("mt6323regulator"),	\
 		.ops = &mt6323_volt_fixed_ops,				\
 		.type = REGULATOR_VOLTAGE,				\
 		.id = MT6323_ID_##vreg,					\
diff --git a/drivers/regulator/mt6358-regulator.c b/drivers/regulator/mt6358-regulator.c
index 13cb6ac9a8929..f5c478d7baaf2 100644
--- a/drivers/regulator/mt6358-regulator.c
+++ b/drivers/regulator/mt6358-regulator.c
@@ -44,6 +44,7 @@ struct mt6358_regulator_info {
 	.desc = {	\
 		.name = #vreg,	\
 		.of_match = of_match_ptr(match),	\
+		.regulators_node = of_match_ptr("mt6358regulator"),	\
 		.ops = &mt6358_volt_range_ops,	\
 		.type = REGULATOR_VOLTAGE,	\
 		.id = MT6358_ID_##vreg,		\
@@ -74,6 +75,7 @@ struct mt6358_regulator_info {
 	.desc = {	\
 		.name = #vreg,	\
 		.of_match = of_match_ptr(match),	\
+		.regulators_node = of_match_ptr("mt6358regulator"),	\
 		.ops = &mt6358_volt_table_ops,	\
 		.type = REGULATOR_VOLTAGE,	\
 		.id = MT6358_ID_##vreg,	\
@@ -99,6 +101,7 @@ struct mt6358_regulator_info {
 	.desc = {	\
 		.name = #vreg,	\
 		.of_match = of_match_ptr(match),	\
+		.regulators_node = of_match_ptr("mt6358regulator"),	\
 		.ops = &mt6358_volt_range_ops,	\
 		.type = REGULATOR_VOLTAGE,	\
 		.id = MT6358_ID_##vreg,	\
@@ -124,6 +127,7 @@ struct mt6358_regulator_info {
 	.desc = {	\
 		.name = #vreg,	\
 		.of_match = of_match_ptr(match),	\
+		.regulators_node = of_match_ptr("mt6358regulator"),	\
 		.ops = &mt6358_volt_fixed_ops,	\
 		.type = REGULATOR_VOLTAGE,	\
 		.id = MT6358_ID_##vreg,	\
diff --git a/drivers/regulator/mt6397-regulator.c b/drivers/regulator/mt6397-regulator.c
index 0a30df5e414fc..9e8589f773eaa 100644
--- a/drivers/regulator/mt6397-regulator.c
+++ b/drivers/regulator/mt6397-regulator.c
@@ -42,6 +42,7 @@ struct mt6397_regulator_info {
 	.desc = {							\
 		.name = #vreg,						\
 		.of_match = of_match_ptr(match),			\
+		.regulators_node = of_match_ptr("mt6397regulator"),	\
 		.ops = &mt6397_volt_range_ops,				\
 		.type = REGULATOR_VOLTAGE,				\
 		.id = MT6397_ID_##vreg,					\
@@ -70,6 +71,7 @@ struct mt6397_regulator_info {
 	.desc = {							\
 		.name = #vreg,						\
 		.of_match = of_match_ptr(match),			\
+		.regulators_node = of_match_ptr("mt6397regulator"),	\
 		.ops = &mt6397_volt_table_ops,				\
 		.type = REGULATOR_VOLTAGE,				\
 		.id = MT6397_ID_##vreg,					\
@@ -89,6 +91,7 @@ struct mt6397_regulator_info {
 	.desc = {							\
 		.name = #vreg,						\
 		.of_match = of_match_ptr(match),			\
+		.regulators_node = of_match_ptr("mt6397regulator"),	\
 		.ops = &mt6397_volt_fixed_ops,				\
 		.type = REGULATOR_VOLTAGE,				\
 		.id = MT6397_ID_##vreg,					\
@@ -396,16 +399,9 @@ static const struct platform_device_id mt6397_platform_ids[] = {
 };
 MODULE_DEVICE_TABLE(platform, mt6397_platform_ids);
 
-static const struct of_device_id mt6397_of_match[] = {
-	{ .compatible = "mediatek,mt6397-regulator", },
-	{ /* sentinel */ },
-};
-MODULE_DEVICE_TABLE(of, mt6397_of_match);
-
 static struct platform_driver mt6397_regulator_driver = {
 	.driver = {
 		.name = "mt6397-regulator",
-		.of_match_table = of_match_ptr(mt6397_of_match),
 	},
 	.probe = mt6397_regulator_probe,
 	.id_table = mt6397_platform_ids,